diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
new file mode 100644
index 9c3d096..feed71e
*** a/src/backend/utils/cache/relcache.c
--- b/src/backend/utils/cache/relcache.c
*************** RelationParseRelOptions(Relation relatio
*** 445,451 ****
  	options = extractRelOptions(tuple,
  								GetPgClassDescriptor(),
  								relation->rd_rel->relkind == RELKIND_INDEX ?
! 								relation->rd_am->amoptions : InvalidOid);
  
  	/*
  	 * Copy parsed data into CacheMemoryContext.  To guard against the
--- 445,451 ----
  	options = extractRelOptions(tuple,
  								GetPgClassDescriptor(),
  								relation->rd_rel->relkind == RELKIND_INDEX ?
! 								relation->amroutine->amoptions : NULL);
  
  	/*
  	 * Copy parsed data into CacheMemoryContext.  To guard against the
*************** RelationInitPhysicalAddr(Relation relati
*** 1160,1172 ****
  }
  
  /*
   * Initialize index-access-method support data for an index relation
   */
  void
  RelationInitIndexAccessInfo(Relation relation)
  {
  	HeapTuple	tuple;
- 	Form_pg_am	aform;
  	Datum		indcollDatum;
  	Datum		indclassDatum;
  	Datum		indoptionDatum;
--- 1160,1237 ----
  }
  
  /*
+  * GetIndexAmRoutine - call the specified access method handler routine
+  * to get its IndexAmRoutine struct.
+  */
+ IndexAmRoutine *
+ GetIndexAmRoutine(Oid amhandler)
+ {
+ 	Datum			datum;
+ 	IndexAmRoutine *routine;
+ 
+ 	datum = OidFunctionCall0(amhandler);
+ 	routine = (IndexAmRoutine *) DatumGetPointer(datum);
+ 
+ 	if (routine == NULL || !IsA(routine, IndexAmRoutine))
+ 		elog(ERROR, "index access method handler function %u did not return an IndexAmRoutine struct",
+ 			 amhandler);
+ 
+ 	return routine;
+ }
+ 
+ /*
+  * GetIndexAmRoutine - look up the handler of the access method
+  * for the given OID, and retrieve its IndexAmRoutine struct.
+  */
+ IndexAmRoutine *
+ GetIndexAmRoutineByAmId(Oid amoid)
+ {
+ 	HeapTuple		tuple;
+ 	regproc			amhandler;
+ 	Form_pg_am		amform;
+ 
+ 	/* Get handler function OID for the access method */
+ 	tuple = SearchSysCache1(AMOID, ObjectIdGetDatum(amoid));
+ 	if (!HeapTupleIsValid(tuple))
+ 		elog(ERROR, "cache lookup failed for access method %u",
+ 			 amoid);
+ 	amform = (Form_pg_am) GETSTRUCT(tuple);
+ 	amhandler = amform->amhandler;
+ 
+ 	/* Complain if handler OID is invalid */
+ 	if (!RegProcedureIsValid(amhandler))
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+ 				 errmsg("index access method \"%s\" does not have a handler",
+ 						NameStr(amform->amname))));
+ 	ReleaseSysCache(tuple);
+ 
+ 	/* And finally, call the handler function. */
+ 	return GetIndexAmRoutine(amhandler);
+ }
+ 
+ /*
+  * Initialize IndexAmRoutine for relation.
+  */
+ void
+ InitIndexAmRoutine(Relation relation)
+ {
+ 	IndexAmRoutine	*result, *tmp;
+ 
+ 	result = (IndexAmRoutine *) MemoryContextAlloc(relation->rd_indexcxt,
+ 												sizeof(IndexAmRoutine));
+ 	tmp = GetIndexAmRoutine(relation->rd_am->amhandler);
+ 	memcpy(result, tmp, sizeof(IndexAmRoutine));
+ 	relation->amroutine = result;
+ }
+ 
+ /*
   * Initialize index-access-method support data for an index relation
   */
  void
  RelationInitIndexAccessInfo(Relation relation)
  {
  	HeapTuple	tuple;
  	Datum		indcollDatum;
  	Datum		indclassDatum;
  	Datum		indoptionDatum;
*************** RelationInitIndexAccessInfo(Relation rel
*** 1178,1183 ****
--- 1243,1249 ----
  	MemoryContext oldcontext;
  	int			natts;
  	uint16		amsupport;
+ 	Form_pg_am	aform;
  
  	/*
  	 * Make a copy of the pg_index entry for the index.  Since pg_index
*************** RelationInitIndexAccessInfo(Relation rel
*** 1211,1217 ****
  	if (natts != relation->rd_index->indnatts)
  		elog(ERROR, "relnatts disagrees with indnatts for index %u",
  			 RelationGetRelid(relation));
- 	amsupport = aform->amsupport;
  
  	/*
  	 * Make the private context to hold index access info.  The reason we need
--- 1277,1282 ----
*************** RelationInitIndexAccessInfo(Relation rel
*** 1228,1233 ****
--- 1293,1303 ----
  									 ALLOCSET_SMALL_MAXSIZE);
  	relation->rd_indexcxt = indexcxt;
  
+ 	/* Initialize index AM routine */
+ 	InitIndexAmRoutine(relation);
+ 
+ 	amsupport = relation->amroutine->amsupport;
+ 
  	/*
  	 * Allocate arrays to hold data
  	 */
*************** load_relcache_init_file(bool shared)
*** 4743,4749 ****
  			Oid		   *opfamily;
  			Oid		   *opcintype;
  			RegProcedure *support;
- 			int			nsupport;
  			int16	   *indoption;
  			Oid		   *indcollation;
  
--- 4813,4818 ----
*************** load_relcache_init_file(bool shared)
*** 4771,4776 ****
--- 4840,4846 ----
  			if (fread(am, 1, len, fp) != len)
  				goto read_failed;
  			rel->rd_am = am;
+ 			rel->amroutine = NULL;
  
  			/*
  			 * prepare index info context --- parameters should match
*************** load_relcache_init_file(bool shared)
*** 4832,4843 ****
  
  			rel->rd_indoption = indoption;
  
  			/* set up zeroed fmgr-info vectors */
  			rel->rd_aminfo = (RelationAmInfo *)
  				MemoryContextAllocZero(indexcxt, sizeof(RelationAmInfo));
- 			nsupport = relform->relnatts * am->amsupport;
  			rel->rd_supportinfo = (FmgrInfo *)
! 				MemoryContextAllocZero(indexcxt, nsupport * sizeof(FmgrInfo));
  		}
  		else
  		{
--- 4902,4914 ----
  
  			rel->rd_indoption = indoption;
  
+ 			InitIndexAmRoutine(rel);
+ 
  			/* set up zeroed fmgr-info vectors */
  			rel->rd_aminfo = (RelationAmInfo *)
  				MemoryContextAllocZero(indexcxt, sizeof(RelationAmInfo));
  			rel->rd_supportinfo = (FmgrInfo *)
! 				MemoryContextAllocZero(indexcxt, relform->relnatts * rel->amroutine->amsupport * sizeof(FmgrInfo));
  		}
  		else
  		{
*************** write_relcache_init_file(bool shared)
*** 5106,5112 ****
  
  			/* next, write the vector of support procedure OIDs */
  			write_item(rel->rd_support,
! 				  relform->relnatts * (am->amsupport * sizeof(RegProcedure)),
  					   fp);
  
  			/* next, write the vector of collation OIDs */
--- 5177,5183 ----
  
  			/* next, write the vector of support procedure OIDs */
  			write_item(rel->rd_support,
! 				  relform->relnatts * (rel->amroutine->amsupport * sizeof(RegProcedure)),
  					   fp);
  
  			/* next, write the vector of collation OIDs */
diff --git a/src/include/access/amapi.h b/src/include/access/amapi.h
new file mode 100644
index ...2e0257a
*** a/src/include/access/amapi.h
--- b/src/include/access/amapi.h
***************
*** 0 ****
--- 1,169 ----
+ /*-------------------------------------------------------------------------
+  *
+  * amapi.h
+  *	  API for access methods
+  *
+  * Copyright (c) 2015, PostgreSQL Global Development Group
+  *
+  * src/include/access/amapi.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef AMAPI_H
+ #define AMAPI_H
+ 
+ #include "access/genam.h"
+ #include "catalog/opfam_internal.h"
+ #include "nodes/relation.h"
+ 
+ /*
+  * Callback function signatures --- see indexam.sgml for more info.
+  */
+ 
+ /* "insert this tuple" function */
+ typedef bool
+ (*aminsert_function) (Relation indexRelation,
+ 					  Datum *values,
+ 					  bool *isnull,
+ 					  ItemPointer heap_tid,
+ 					  Relation heapRelation,
+ 					  IndexUniqueCheck checkUnique);
+ 
+ /* "prepare for index scan" function */
+ typedef IndexScanDesc
+ (*ambeginscan_function) (Relation indexRelation,
+ 						 int nkeys,
+ 						 int norderbys);
+ 
+ /* "next valid tuple" function, or NULL */
+ typedef bool
+ (*amgettuple_function) (IndexScanDesc scan,
+ 						ScanDirection direction);
+ 
+ /* "fetch all valid tuples" function, or NULL */
+ typedef int64
+ (*amgetbitmap_function) (IndexScanDesc scan,
+ 						 TIDBitmap *tbm);
+ 
+ /* "(re)start index scan" function */
+ typedef void
+ (*amrescan_function) (IndexScanDesc scan,
+ 					  ScanKey keys,
+ 					  int nkeys,
+ 					  ScanKey orderbys,
+ 					  int norderbys);
+ 
+ /* "end index scan" function */
+ typedef void
+ (*amendscan_function) (IndexScanDesc scan);
+ 
+ /* "mark current scan position" function */
+ typedef void
+ (*ammarkpos_function) (IndexScanDesc scan);
+ 
+ /* "restore marked scan position" function */
+ typedef void
+ (*amrestrpos_function) (IndexScanDesc scan);
+ 
+ /* "build new index" function */
+ typedef IndexBuildResult *
+ (*ambuild_function) (Relation heapRelation,
+ 					 Relation indexRelation,
+ 					 IndexInfo *indexInfo);
+ 
+ /* "build empty index" function */
+ typedef void
+ (*ambuildempty_function) (Relation indexRelation);
+ 
+ /* bulk-delete function */
+ typedef IndexBulkDeleteResult *
+ (*ambulkdelete_function) (IndexVacuumInfo *info,
+ 						  IndexBulkDeleteResult *stats,
+ 						  IndexBulkDeleteCallback callback,
+ 						  void *callback_state);
+ 
+ /* post-VACUUM cleanup function */
+ typedef IndexBulkDeleteResult *
+ (*amvacuumcleanup_function) (IndexVacuumInfo *info,
+ 							 IndexBulkDeleteResult *stats);
+ 
+ /* can indexscan return IndexTuples? */
+ typedef bool
+ (*amcanreturn_function) (Relation indexRelation, int attno);
+ 
+ /* estimate cost of an indexscan */
+ typedef void
+ (*amcostestimate_function) (PlannerInfo *root,
+ 							IndexPath *path,
+ 							double loop_count,
+ 							Cost *indexStartupCost,
+ 							Cost *indexTotalCost,
+ 							Selectivity *indexSelectivity,
+ 							double *indexCorrelation);
+ 
+ /* parse AM-specific parameters */
+ typedef bytea *
+ (*amoptions_function) (Datum reloptions,
+ 					   bool validate);
+ 
+ /* validate oplass */
+ typedef void
+ (*amvalidate_function) (OpClassInfo *opclass);
+ 
+ 
+ struct IndexAmRoutine
+ {
+ 	NodeTag		type;
+ 
+ 	/*
+ 	 * Total number of strategies (operators) by which we can traverse/search
+ 	 * this AM. Zero if AM does not have a fixed set of strategy assignments.
+ 	 */
+ 	int16						amstrategies;
+ 	/* total number of support functions that this AM uses */
+ 	int16						amsupport;
+ 	/* does AM support order by column value? */
+ 	bool						amcanorder;
+ 	/* does AM support order by operator result? */
+ 	bool						amcanorderbyop;
+ 	/* does AM support backward scan? */
+ 	bool						amcanbackward;
+ 	/* does AM support UNIQUE indexes? */
+ 	bool						amcanunique;
+ 	/* does AM support multi-column indexes? */
+ 	bool						amcanmulticol;
+ 	/* can query omit key for the first column? */
+ 	bool						amoptionalkey;
+ 	/* can AM handle ScalarArrayOpExpr quals? */
+ 	bool						amsearcharray;
+ 	/* can AM search for NULL/NOT NULL entries? */
+ 	bool						amsearchnulls;
+ 	/* can storage type differ from column type? */
+ 	bool						amstorage;
+ 	/* does AM support cluster command? */
+ 	bool						amclusterable;
+ 	/* does AM handle predicate locks? */
+ 	bool						ampredlocks;
+ 	/* type of data in index, or InvalidOid */
+ 	Oid							amkeytype;
+ 
+ 	/* interface functions */
+ 	aminsert_function			aminsert;
+ 	ambeginscan_function		ambeginscan;
+ 	amgettuple_function			amgettuple;
+ 	amgetbitmap_function		amgetbitmap;
+ 	amrescan_function			amrescan;
+ 	amendscan_function			amendscan;
+ 	ammarkpos_function			ammarkpos;
+ 	amrestrpos_function			amrestrpos;
+ 	ambuild_function			ambuild;
+ 	ambuildempty_function		ambuildempty;
+ 	ambulkdelete_function		ambulkdelete;
+ 	amvacuumcleanup_function	amvacuumcleanup;
+ 	amcanreturn_function		amcanreturn;
+ 	amcostestimate_function		amcostestimate;
+ 	amoptions_function			amoptions;
+ 	amvalidate_function			amvalidate;
+ };
+ 
+ #endif   /* AMAPI_H */
diff --git a/src/include/access/brin.h b/src/include/access/brin.h
new file mode 100644
index e72fb2d..5ae5722
*** a/src/include/access/brin.h
--- b/src/include/access/brin.h
***************
*** 10,15 ****
--- 10,16 ----
  #ifndef BRIN_H
  #define BRIN_H
  
+ #include "access/amapi.h"
  #include "fmgr.h"
  #include "nodes/execnodes.h"
  #include "utils/relcache.h"
***************
*** 18,36 ****
  /*
   * prototypes for functions in brin.c (external entry points for BRIN)
   */
! extern Datum brinbuild(PG_FUNCTION_ARGS);
! extern Datum brinbuildempty(PG_FUNCTION_ARGS);
! extern Datum brininsert(PG_FUNCTION_ARGS);
! extern Datum brinbeginscan(PG_FUNCTION_ARGS);
! extern Datum bringetbitmap(PG_FUNCTION_ARGS);
! extern Datum brinrescan(PG_FUNCTION_ARGS);
! extern Datum brinendscan(PG_FUNCTION_ARGS);
! extern Datum brinmarkpos(PG_FUNCTION_ARGS);
! extern Datum brinrestrpos(PG_FUNCTION_ARGS);
! extern Datum brinbulkdelete(PG_FUNCTION_ARGS);
! extern Datum brinvacuumcleanup(PG_FUNCTION_ARGS);
! extern Datum brincostestimate(PG_FUNCTION_ARGS);
! extern Datum brinoptions(PG_FUNCTION_ARGS);
  
  /*
   * Storage type for BRIN's reloptions
--- 19,51 ----
  /*
   * prototypes for functions in brin.c (external entry points for BRIN)
   */
! extern Datum brinhandler(PG_FUNCTION_ARGS);
! extern void brinvalidate(OpClassInfo *opclass);
! extern IndexBuildResult *brinbuild(Relation heap, Relation index,
! 								   IndexInfo *indexInfo);
! extern void brinbuildempty(Relation index);
! extern bool brininsert(Relation idxRel, Datum *values, bool *nulls,
! 					   ItemPointer heaptid, Relation heapRel,
! 					   IndexUniqueCheck checkUnique);
! extern IndexScanDesc brinbeginscan(Relation r, int nkeys, int norderbys);
! extern int64 bringetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
! extern void brinrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 					   ScanKey orderbys, int norderbys);
! extern void brinendscan(IndexScanDesc scan);
! extern void brinmarkpos(IndexScanDesc scan);
! extern void brinrestrpos(IndexScanDesc scan);
! extern IndexBulkDeleteResult *brinbulkdelete(IndexVacuumInfo *info,
! 											 IndexBulkDeleteResult *stats,
! 											 IndexBulkDeleteCallback callback,
! 											 void *callback_state);
! extern IndexBulkDeleteResult *brinvacuumcleanup(IndexVacuumInfo *info,
! 												IndexBulkDeleteResult *stats);
! extern void brincostestimate(PlannerInfo *root, IndexPath *path,
! 							 double loop_count, Cost *indexStartupCost,
! 							 Cost *indexTotalCost,
! 							 Selectivity *indexSelectivity,
! 							 double *indexCorrelation);
! extern bytea *brinoptions(Datum reloptions, bool validate);
  
  /*
   * Storage type for BRIN's reloptions
diff --git a/src/include/access/brin_internal.h b/src/include/access/brin_internal.h
new file mode 100644
index 6be199e..cd72544
*** a/src/include/access/brin_internal.h
--- b/src/include/access/brin_internal.h
*************** typedef struct BrinDesc
*** 71,76 ****
--- 71,77 ----
  #define BRIN_PROCNUM_ADDVALUE		2
  #define BRIN_PROCNUM_CONSISTENT		3
  #define BRIN_PROCNUM_UNION			4
+ #define BRIN_MANDATORY_NPROCS		4
  /* procedure numbers up to 10 are reserved for BRIN future expansion */
  
  #undef BRIN_DEBUG
diff --git a/src/include/access/gin_private.h b/src/include/access/gin_private.h
new file mode 100644
index 5021887..a77d43f
*** a/src/include/access/gin_private.h
--- b/src/include/access/gin_private.h
***************
*** 10,16 ****
  #ifndef GIN_PRIVATE_H
  #define GIN_PRIVATE_H
  
! #include "access/genam.h"
  #include "access/gin.h"
  #include "access/itup.h"
  #include "fmgr.h"
--- 10,16 ----
  #ifndef GIN_PRIVATE_H
  #define GIN_PRIVATE_H
  
! #include "access/amapi.h"
  #include "access/gin.h"
  #include "access/itup.h"
  #include "fmgr.h"
*************** typedef struct ginxlogDeleteListPages
*** 593,599 ****
  
  
  /* ginutil.c */
! extern Datum ginoptions(PG_FUNCTION_ARGS);
  extern void initGinState(GinState *state, Relation index);
  extern Buffer GinNewBuffer(Relation index);
  extern void GinInitBuffer(Buffer b, uint32 f);
--- 593,601 ----
  
  
  /* ginutil.c */
! extern Datum ginhandler(PG_FUNCTION_ARGS);
! extern void ginvalidate(OpClassInfo *opclass);
! extern bytea *ginoptions(Datum reloptions, bool validate);
  extern void initGinState(GinState *state, Relation index);
  extern Buffer GinNewBuffer(Relation index);
  extern void GinInitBuffer(Buffer b, uint32 f);
*************** extern Datum gintuple_get_key(GinState *
*** 614,622 ****
  				 GinNullCategory *category);
  
  /* gininsert.c */
! extern Datum ginbuild(PG_FUNCTION_ARGS);
! extern Datum ginbuildempty(PG_FUNCTION_ARGS);
! extern Datum gininsert(PG_FUNCTION_ARGS);
  extern void ginEntryInsert(GinState *ginstate,
  			   OffsetNumber attnum, Datum key, GinNullCategory category,
  			   ItemPointerData *items, uint32 nitem,
--- 616,627 ----
  				 GinNullCategory *category);
  
  /* gininsert.c */
! extern IndexBuildResult *ginbuild(Relation heap, Relation index,
! 								  IndexInfo *indexInfo);
! extern void ginbuildempty(Relation index);
! extern bool gininsert(Relation index, Datum *values, bool *isnull,
! 					  ItemPointer ht_ctid, Relation heapRel,
! 					  IndexUniqueCheck checkUnique);
  extern void ginEntryInsert(GinState *ginstate,
  			   OffsetNumber attnum, Datum key, GinNullCategory category,
  			   ItemPointerData *items, uint32 nitem,
*************** typedef struct GinScanOpaqueData
*** 867,889 ****
  
  typedef GinScanOpaqueData *GinScanOpaque;
  
! extern Datum ginbeginscan(PG_FUNCTION_ARGS);
! extern Datum ginendscan(PG_FUNCTION_ARGS);
! extern Datum ginrescan(PG_FUNCTION_ARGS);
! extern Datum ginmarkpos(PG_FUNCTION_ARGS);
! extern Datum ginrestrpos(PG_FUNCTION_ARGS);
  extern void ginNewScanKey(IndexScanDesc scan);
  extern void ginFreeScanKeys(GinScanOpaque so);
  
  /* ginget.c */
! extern Datum gingetbitmap(PG_FUNCTION_ARGS);
  
  /* ginlogic.c */
  extern void ginInitConsistentFunction(GinState *ginstate, GinScanKey key);
  
  /* ginvacuum.c */
! extern Datum ginbulkdelete(PG_FUNCTION_ARGS);
! extern Datum ginvacuumcleanup(PG_FUNCTION_ARGS);
  extern ItemPointer ginVacuumItemPointers(GinVacuumState *gvs,
  					  ItemPointerData *items, int nitem, int *nremaining);
  
--- 872,899 ----
  
  typedef GinScanOpaqueData *GinScanOpaque;
  
! extern IndexScanDesc ginbeginscan(Relation rel, int nkeys, int norderbys);
! extern void ginendscan(IndexScanDesc scan);
! extern void ginrescan(IndexScanDesc scan, ScanKey key, int nkeys,
! 					  ScanKey orderbys, int norderbys);
! extern void ginmarkpos(IndexScanDesc scan);
! extern void ginrestrpos(IndexScanDesc scan);
  extern void ginNewScanKey(IndexScanDesc scan);
  extern void ginFreeScanKeys(GinScanOpaque so);
  
  /* ginget.c */
! extern int64 gingetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
  
  /* ginlogic.c */
  extern void ginInitConsistentFunction(GinState *ginstate, GinScanKey key);
  
  /* ginvacuum.c */
! extern IndexBulkDeleteResult *ginbulkdelete(IndexVacuumInfo *info,
! 											IndexBulkDeleteResult *stats,
! 											IndexBulkDeleteCallback callback,
! 											void *callback_state);
! extern IndexBulkDeleteResult *ginvacuumcleanup(IndexVacuumInfo *info,
! 											   IndexBulkDeleteResult *stats);
  extern ItemPointer ginVacuumItemPointers(GinVacuumState *gvs,
  					  ItemPointerData *items, int nitem, int *nremaining);
  
diff --git a/src/include/access/gist_private.h b/src/include/access/gist_private.h
new file mode 100644
index 1a77982..35fb34a
*** a/src/include/access/gist_private.h
--- b/src/include/access/gist_private.h
***************
*** 14,19 ****
--- 14,20 ----
  #ifndef GIST_PRIVATE_H
  #define GIST_PRIVATE_H
  
+ #include "access/amapi.h"
  #include "access/gist.h"
  #include "access/itup.h"
  #include "access/xlogreader.h"
*************** typedef struct GiSTOptions
*** 426,434 ****
  } GiSTOptions;
  
  /* gist.c */
! extern Datum gistbuildempty(PG_FUNCTION_ARGS);
! extern Datum gistinsert(PG_FUNCTION_ARGS);
! extern Datum gistcanreturn(PG_FUNCTION_ARGS);
  extern MemoryContext createTempGistContext(void);
  extern GISTSTATE *initGISTstate(Relation index);
  extern void freeGISTstate(GISTSTATE *giststate);
--- 427,439 ----
  } GiSTOptions;
  
  /* gist.c */
! extern Datum gisthandler(PG_FUNCTION_ARGS);
! extern void gistvalidate(OpClassInfo *opclass);
! extern void gistbuildempty(Relation index);
! extern bool gistinsert(Relation r, Datum *values, bool *isnull,
! 					   ItemPointer ht_ctid, Relation heapRel,
! 					   IndexUniqueCheck checkUnique);
! extern bool gistcanreturn(Relation index, int attno);
  extern MemoryContext createTempGistContext(void);
  extern GISTSTATE *initGISTstate(Relation index);
  extern void freeGISTstate(GISTSTATE *giststate);
*************** extern XLogRecPtr gistXLogSplit(RelFileN
*** 474,481 ****
  			  Buffer leftchild, bool markfollowright);
  
  /* gistget.c */
! extern Datum gistgettuple(PG_FUNCTION_ARGS);
! extern Datum gistgetbitmap(PG_FUNCTION_ARGS);
  
  /* gistutil.c */
  
--- 479,486 ----
  			  Buffer leftchild, bool markfollowright);
  
  /* gistget.c */
! extern bool gistgettuple(IndexScanDesc scan, ScanDirection dir);
! extern int64 gistgetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
  
  /* gistutil.c */
  
*************** extern Datum gistgetbitmap(PG_FUNCTION_A
*** 485,491 ****
  #define GIST_MIN_FILLFACTOR			10
  #define GIST_DEFAULT_FILLFACTOR		90
  
! extern Datum gistoptions(PG_FUNCTION_ARGS);
  extern bool gistfitpage(IndexTuple *itvec, int len);
  extern bool gistnospace(Page page, IndexTuple *itvec, int len, OffsetNumber todelete, Size freespace);
  extern void gistcheckpage(Relation rel, Buffer buf);
--- 490,496 ----
  #define GIST_MIN_FILLFACTOR			10
  #define GIST_DEFAULT_FILLFACTOR		90
  
! extern bytea *gistoptions(Datum reloptions, bool validate);
  extern bool gistfitpage(IndexTuple *itvec, int len);
  extern bool gistnospace(Page page, IndexTuple *itvec, int len, OffsetNumber todelete, Size freespace);
  extern void gistcheckpage(Relation rel, Buffer buf);
*************** extern void gistMakeUnionKey(GISTSTATE *
*** 534,541 ****
  extern XLogRecPtr gistGetFakeLSN(Relation rel);
  
  /* gistvacuum.c */
! extern Datum gistbulkdelete(PG_FUNCTION_ARGS);
! extern Datum gistvacuumcleanup(PG_FUNCTION_ARGS);
  
  /* gistsplit.c */
  extern void gistSplitByKey(Relation r, Page page, IndexTuple *itup,
--- 539,550 ----
  extern XLogRecPtr gistGetFakeLSN(Relation rel);
  
  /* gistvacuum.c */
! extern IndexBulkDeleteResult *gistbulkdelete(IndexVacuumInfo *info,
! 											 IndexBulkDeleteResult *stats,
! 											 IndexBulkDeleteCallback callback,
! 											 void *callback_state);
! extern IndexBulkDeleteResult *gistvacuumcleanup(IndexVacuumInfo *info,
! 												IndexBulkDeleteResult *stats);
  
  /* gistsplit.c */
  extern void gistSplitByKey(Relation r, Page page, IndexTuple *itup,
*************** extern void gistSplitByKey(Relation r, P
*** 544,550 ****
  			   int attno);
  
  /* gistbuild.c */
! extern Datum gistbuild(PG_FUNCTION_ARGS);
  extern void gistValidateBufferingOption(char *value);
  
  /* gistbuildbuffers.c */
--- 553,560 ----
  			   int attno);
  
  /* gistbuild.c */
! extern IndexBuildResult *gistbuild(Relation heap, Relation index,
! 								   IndexInfo *indexInfo);
  extern void gistValidateBufferingOption(char *value);
  
  /* gistbuildbuffers.c */
diff --git a/src/include/access/gistscan.h b/src/include/access/gistscan.h
new file mode 100644
index 15cb3d1..0e6afe9
*** a/src/include/access/gistscan.h
--- b/src/include/access/gistscan.h
***************
*** 16,25 ****
  
  #include "fmgr.h"
  
! extern Datum gistbeginscan(PG_FUNCTION_ARGS);
! extern Datum gistrescan(PG_FUNCTION_ARGS);
! extern Datum gistmarkpos(PG_FUNCTION_ARGS);
! extern Datum gistrestrpos(PG_FUNCTION_ARGS);
! extern Datum gistendscan(PG_FUNCTION_ARGS);
  
  #endif   /* GISTSCAN_H */
--- 16,26 ----
  
  #include "fmgr.h"
  
! extern IndexScanDesc gistbeginscan(Relation r, int nkeys, int norderbys);
! extern void gistrescan(IndexScanDesc scan, ScanKey key, int nkeys,
! 					   ScanKey orderbys, int norderbys);
! extern void gistmarkpos(IndexScanDesc scan);
! extern void gistrestrpos(IndexScanDesc scan);
! extern void gistendscan(IndexScanDesc scan);
  
  #endif   /* GISTSCAN_H */
diff --git a/src/include/access/hash.h b/src/include/access/hash.h
new file mode 100644
index 97cb859..9595c6b
*** a/src/include/access/hash.h
--- b/src/include/access/hash.h
***************
*** 17,23 ****
  #ifndef HASH_H
  #define HASH_H
  
! #include "access/genam.h"
  #include "access/itup.h"
  #include "access/sdir.h"
  #include "access/xlogreader.h"
--- 17,23 ----
  #ifndef HASH_H
  #define HASH_H
  
! #include "access/amapi.h"
  #include "access/itup.h"
  #include "access/sdir.h"
  #include "access/xlogreader.h"
*************** typedef HashMetaPageData *HashMetaPage;
*** 243,261 ****
  
  /* public routines */
  
! extern Datum hashbuild(PG_FUNCTION_ARGS);
! extern Datum hashbuildempty(PG_FUNCTION_ARGS);
! extern Datum hashinsert(PG_FUNCTION_ARGS);
! extern Datum hashbeginscan(PG_FUNCTION_ARGS);
! extern Datum hashgettuple(PG_FUNCTION_ARGS);
! extern Datum hashgetbitmap(PG_FUNCTION_ARGS);
! extern Datum hashrescan(PG_FUNCTION_ARGS);
! extern Datum hashendscan(PG_FUNCTION_ARGS);
! extern Datum hashmarkpos(PG_FUNCTION_ARGS);
! extern Datum hashrestrpos(PG_FUNCTION_ARGS);
! extern Datum hashbulkdelete(PG_FUNCTION_ARGS);
! extern Datum hashvacuumcleanup(PG_FUNCTION_ARGS);
! extern Datum hashoptions(PG_FUNCTION_ARGS);
  
  /*
   * Datatype-specific hash functions in hashfunc.c.
--- 243,271 ----
  
  /* public routines */
  
! extern Datum hashhandler(PG_FUNCTION_ARGS);
! extern void hashvalidate(OpClassInfo *opclass);
! extern IndexBuildResult *hashbuild(Relation heap, Relation index,
! 								   IndexInfo *indexInfo);
! extern void hashbuildempty(Relation index);
! extern bool hashinsert(Relation rel, Datum *values, bool *isnull,
! 					   ItemPointer ht_ctid, Relation heapRel,
! 					   IndexUniqueCheck checkUnique);
! extern IndexScanDesc hashbeginscan(Relation rel, int nkeys, int norderbys);
! extern bool hashgettuple(IndexScanDesc scan, ScanDirection dir);
! extern int64 hashgetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
! extern void hashrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 					   ScanKey orderbys, int norderbys);
! extern void hashendscan(IndexScanDesc scan);
! extern void hashmarkpos(IndexScanDesc scan);
! extern void hashrestrpos(IndexScanDesc scan);
! extern IndexBulkDeleteResult *hashbulkdelete(IndexVacuumInfo *info,
! 											 IndexBulkDeleteResult *stats,
! 											 IndexBulkDeleteCallback callback,
! 											 void *callback_state);
! extern IndexBulkDeleteResult *hashvacuumcleanup(IndexVacuumInfo *info,
! 												IndexBulkDeleteResult *stats);
! extern bytea *hashoptions(Datum reloptions, bool validate);
  
  /*
   * Datatype-specific hash functions in hashfunc.c.
diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
new file mode 100644
index 9e48efd..4fab0a3
*** a/src/include/access/nbtree.h
--- b/src/include/access/nbtree.h
***************
*** 14,26 ****
  #ifndef NBTREE_H
  #define NBTREE_H
  
! #include "access/genam.h"
  #include "access/itup.h"
  #include "access/sdir.h"
  #include "access/xlogreader.h"
  #include "catalog/pg_index.h"
  #include "lib/stringinfo.h"
  #include "storage/bufmgr.h"
  
  /* There's room for a 16-bit vacuum cycle ID in BTPageOpaqueData */
  typedef uint16 BTCycleId;
--- 14,27 ----
  #ifndef NBTREE_H
  #define NBTREE_H
  
! #include "access/amapi.h"
  #include "access/itup.h"
  #include "access/sdir.h"
  #include "access/xlogreader.h"
  #include "catalog/pg_index.h"
  #include "lib/stringinfo.h"
  #include "storage/bufmgr.h"
+ #include "utils/selfuncs.h"
  
  /* There's room for a 16-bit vacuum cycle ID in BTPageOpaqueData */
  typedef uint16 BTCycleId;
*************** typedef BTScanOpaqueData *BTScanOpaque;
*** 652,671 ****
  /*
   * prototypes for functions in nbtree.c (external entry points for btree)
   */
! extern Datum btbuild(PG_FUNCTION_ARGS);
! extern Datum btbuildempty(PG_FUNCTION_ARGS);
! extern Datum btinsert(PG_FUNCTION_ARGS);
! extern Datum btbeginscan(PG_FUNCTION_ARGS);
! extern Datum btgettuple(PG_FUNCTION_ARGS);
! extern Datum btgetbitmap(PG_FUNCTION_ARGS);
! extern Datum btrescan(PG_FUNCTION_ARGS);
! extern Datum btendscan(PG_FUNCTION_ARGS);
! extern Datum btmarkpos(PG_FUNCTION_ARGS);
! extern Datum btrestrpos(PG_FUNCTION_ARGS);
! extern Datum btbulkdelete(PG_FUNCTION_ARGS);
! extern Datum btvacuumcleanup(PG_FUNCTION_ARGS);
! extern Datum btcanreturn(PG_FUNCTION_ARGS);
! extern Datum btoptions(PG_FUNCTION_ARGS);
  
  /*
   * prototypes for functions in nbtinsert.c
--- 653,683 ----
  /*
   * prototypes for functions in nbtree.c (external entry points for btree)
   */
! extern Datum bthandler(PG_FUNCTION_ARGS);
! extern void btvalidate(OpClassInfo *opclass);
! extern IndexBuildResult *btbuild(Relation heap, Relation index,
! 								 IndexInfo *indexInfo);
! extern void btbuildempty(Relation index);
! extern bool btinsert(Relation rel, Datum *values, bool *isnull,
! 					 ItemPointer ht_ctid, Relation heapRel,
! 					 IndexUniqueCheck checkUnique);
! extern IndexScanDesc btbeginscan(Relation indexRelation,
! 								 int nkeys, int norderbys);
! extern bool btgettuple(IndexScanDesc scan, ScanDirection dir);
! extern int64 btgetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
! extern void btrescan(IndexScanDesc scan, ScanKey keys, int nkeys,
! 					 ScanKey orderbys, int norderbys);
! extern void btendscan(IndexScanDesc scan);
! extern void btmarkpos(IndexScanDesc scan);
! extern void btrestrpos(IndexScanDesc scan);
! extern IndexBulkDeleteResult *btbulkdelete(IndexVacuumInfo *info,
! 										   IndexBulkDeleteResult *stats,
! 										   IndexBulkDeleteCallback callback,
! 										   void *callback_state);
! extern IndexBulkDeleteResult *btvacuumcleanup(IndexVacuumInfo *info,
! 											  IndexBulkDeleteResult *stats);
! extern bool btcanreturn(Relation index, int attno);
! extern bytea *btoptions(Datum reloptions, bool validate);
  
  /*
   * prototypes for functions in nbtinsert.c
diff --git a/src/include/access/reloptions.h b/src/include/access/reloptions.h
new file mode 100644
index 2a3cbcd..7de02d2
*** a/src/include/access/reloptions.h
--- b/src/include/access/reloptions.h
***************
*** 19,24 ****
--- 19,25 ----
  #ifndef RELOPTIONS_H
  #define RELOPTIONS_H
  
+ #include "access/amapi.h"
  #include "access/htup.h"
  #include "access/tupdesc.h"
  #include "nodes/pg_list.h"
*************** extern Datum transformRelOptions(Datum o
*** 258,264 ****
  					bool ignoreOids, bool isReset);
  extern List *untransformRelOptions(Datum options);
  extern bytea *extractRelOptions(HeapTuple tuple, TupleDesc tupdesc,
! 				  Oid amoptions);
  extern relopt_value *parseRelOptions(Datum options, bool validate,
  				relopt_kind kind, int *numrelopts);
  extern void *allocateReloptStruct(Size base, relopt_value *options,
--- 259,265 ----
  					bool ignoreOids, bool isReset);
  extern List *untransformRelOptions(Datum options);
  extern bytea *extractRelOptions(HeapTuple tuple, TupleDesc tupdesc,
! 				  amoptions_function amoptions);
  extern relopt_value *parseRelOptions(Datum options, bool validate,
  				relopt_kind kind, int *numrelopts);
  extern void *allocateReloptStruct(Size base, relopt_value *options,
*************** extern bytea *default_reloptions(Datum r
*** 272,278 ****
  				   relopt_kind kind);
  extern bytea *heap_reloptions(char relkind, Datum reloptions, bool validate);
  extern bytea *view_reloptions(Datum reloptions, bool validate);
! extern bytea *index_reloptions(RegProcedure amoptions, Datum reloptions,
  				 bool validate);
  extern bytea *attribute_reloptions(Datum reloptions, bool validate);
  extern bytea *tablespace_reloptions(Datum reloptions, bool validate);
--- 273,279 ----
  				   relopt_kind kind);
  extern bytea *heap_reloptions(char relkind, Datum reloptions, bool validate);
  extern bytea *view_reloptions(Datum reloptions, bool validate);
! extern bytea *index_reloptions(amoptions_function amoptions, Datum reloptions,
  				 bool validate);
  extern bytea *attribute_reloptions(Datum reloptions, bool validate);
  extern bytea *tablespace_reloptions(Datum reloptions, bool validate);
